package bg.bas.dcl.CorpusTools;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.bootstrap.DOMImplementationRegistry;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;
import org.xml.sax.SAXException;

import bg.bas.dcl.mwe.entities.Word;
import bg.bas.dcl.mwe.lists.IndexLexicon;
import bg.bas.dcl.mwe.lists.TokenToLemmaLexicon;

public class CorpusXMLVerifier {

	static ArrayList<Integer> tokenFrequencyCtr = new ArrayList<Integer>();
	static ArrayList<Integer> lemmaFrequencyCtr = new ArrayList<Integer>();

	static public IndexLexicon tokenLexicon = new IndexLexicon(tokenFrequencyCtr);
	static public IndexLexicon lemmaLexicon = new IndexLexicon(lemmaFrequencyCtr);

	static TokenToLemmaLexicon tokenToLemmaLexicon = new TokenToLemmaLexicon();
	
	static long chunkctr = 1;
	static long mwectr = 1;
	
	static boolean cont = false;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		String pathOriginal = args[0];
//		String pathTagged = args[1];
//		String outpath = args[2];

	    File startingDirectory= new File(pathOriginal);
	    List<File> files = null;
	    try{
	    	files = getFileListing(startingDirectory);
	    	System.out.println(files.size());
	    } catch(Exception e){
	    	System.err.println("GET listing error");
	    }

//	    repairXML(files);
	    removeIncorrectXML(files);

	    
	}
	
	
	public static void repairXML(List<File> files){

		cont = false;
		for(File file : files ){
		      if (file.isFile()){
		    	  
		    	  if (file.getName().contains("00068359")) cont = true;

		    	  if (!cont) continue;
		    	  
		    	  if (file.getName().startsWith("._")) continue;
		    	  if (file.getName().endsWith("~")) continue;
		    	  
		    	  
		    	  try {
		    		  System.out.println(file.getAbsolutePath());
					Scanner sc = new Scanner(file, "UTF-8");
					
					String text = "";
					
					while (sc.hasNextLine()) {
						String l = sc.nextLine();
						
						if (l.contains("<word w=\"&")) {
							String t = l.substring("<word w=\"&".length());
							if (!t.substring(t.indexOf("\"")-1,t.indexOf("\"")).equals(";")) continue;
						}

						l = l.replaceAll("\"\"", "\"");
						l = l.replaceAll("\"''\" ", "\"&quot;\" ");
						l = l.replaceAll("\"''\"", "\"");
						
//						l = l.replaceAll("\"[^\" ]*<[^\" ]*\"", "\"&lt;\"");
//						l = l.replaceAll("\"[^\" ]*>[^\" ]*\"", "\"&gt;\"");
////						l = l.replaceAll("\"'*\"", "\"&apos;\"");
						
	//					if (l.replaceAll("\"&[^\"; ]*\"", "\"X\"").equals(l)) {
							text += l+"\n";
	//					}
						
					}
					
					
					if (!text.trim().endsWith("</text>")) {
						System.err.println("Error in xml: " + file.getAbsolutePath());
						text += "</text>";
					}
					
					String fname = file.getAbsolutePath().replace("/xml-new/", "/xml-verified/");
					makeParent(fname, "/");
					
					Writer wr = new OutputStreamWriter(new FileOutputStream(fname), "UTF-8");
					
					wr.write(text);
					wr.flush();
					wr.close();
					sc.close();
					
					
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		    	  

		    	  
		    	  //	    	System.exit(-1);  
		      }
		}

	}

	public static void removeIncorrectXML(List<File> files){
	    for(File file : files ){
		      if (file.isFile()){
		    	  
		    	  if (file.getName().startsWith("._")) continue;
		    	  if (file.getName().endsWith("~")) continue;
		    	  
		    	  
		    	  
		    	  try {
					Scanner sc = new Scanner(file, "UTF-8");
					
					String text = "";
					boolean start = false;
					boolean needchange = false;
					
					while (sc.hasNextLine()) {
						String l = sc.nextLine();
						
						if (! start) {
							if (!l.startsWith("<?xml")) {
								text += "<?xml version=\"1.0\" ?><text current=\"0\">"+"\n";
								needchange = true;
							}
							start = true;
						}
						
						text += l+"\n";
						
					}
					
					if (needchange) {
						Writer wr1 = new OutputStreamWriter(new FileOutputStream(file.getAbsolutePath()), "UTF-8");
						wr1.write(text);
						wr1.flush();
						wr1.close();
					}
					
					
					DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
		    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
		    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
		    		
		    		Element rootElement = document.getDocumentElement();
		    		
			    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
			    	DOMImplementationLS lsImpl = 
			    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
			    	LSSerializer serializer = lsImpl.createLSSerializer();

			    	NodeList nodes = rootElement.getChildNodes();
					
			    	if (nodes.getLength()<1000) continue;
					
			    	String fname = file.getAbsolutePath().replace("/xml-verified/","/xml-verified-final/");
					makeParent(fname, "/");
					
					Writer wr = new OutputStreamWriter(new FileOutputStream(fname), "UTF-8");
					
					wr.write(text);
					wr.flush();
					wr.close();
					sc.close();
					
					
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ParserConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (SAXException e) {
					// TODO Auto-generated catch block
					System.out.println(file.getAbsolutePath());
					e.printStackTrace();
				} catch (ClassCastException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClassNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InstantiationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		    	  

		    	  
		    	  //	    	System.exit(-1);  
		      }
		}

	}

	  /**
	   * Recursively walk a directory tree and return a List of all
	   * Files found; the List is sorted using File.compareTo().
	   *
	   * @param aStartingDir is a valid directory, which can be read.
	   */
	   static public List<File> getFileListing(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     validateDirectory(aStartingDir);
	     List<File> result = getFileListingNoSort(aStartingDir);
	     Collections.sort(result);
	     return result;
	   }

	   // PRIVATE //
	   static private List<File> getFileListingNoSort(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     List<File> result = new ArrayList<File>();
	     File[] filesAndDirs = aStartingDir.listFiles();
	     List<File> filesDirs = Arrays.asList(filesAndDirs);
	     for(File file : filesDirs) {
	       result.add(file); //always add, even if directory
	       if ( ! file.isFile() ) {
	         //must be a directory
	         //recursive call!
	         List<File> deeperList = getFileListingNoSort(file);
	         result.addAll(deeperList);
	       }
	     }
	     return result;
	   }

	   /**
	   * Directory is valid if it exists, does not represent a file, and can be read.
	   */
	   static private void validateDirectory (
	     File aDirectory
	   ) throws FileNotFoundException {
	     if (aDirectory == null) {
	       throw new IllegalArgumentException("Directory should not be null.");
	     }
	     if (!aDirectory.exists()) {
	       throw new FileNotFoundException("Directory does not exist: " + aDirectory);
	     }
	     if (!aDirectory.isDirectory()) {
	       throw new IllegalArgumentException("Is not a directory: " + aDirectory);
	     }
	     if (!aDirectory.canRead()) {
	       throw new IllegalArgumentException("Directory cannot be read: " + aDirectory);
	     }
	   }

		static void makeParent(String path,String mainPath){
			  String parent = (new File(path)).getParent();
			 
			  if ((new File(parent)).exists()) return;
			  
			  if (!parent.equals(mainPath)) {
				  makeParent(parent, mainPath);
			  } 
			  
			  (new File(parent)).mkdir();
			  
		}

}
