package bg.bas.dcl.CorpusTools;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;
import java.util.TreeMap;

public class HelpClass {
	
	public static void main(String[] args){
		HelpClass h = new HelpClass();
		
//		h.divideFreeNonfreeNondecompFreq("ChiSquare");
//		h.divideFreeNonfreeNondecompFreq("LogLikelihood");
//		h.divideFreeNonfreeNondecompFreq("MutualInformation");
//		h.divideFreeNonfreeNondecompFreq("EnhancedMutualInformation");
//		h.selectMostFreq();
//		h.selectMostFreqSorted();
		
//		h.divideFreeNonfreeNondecompFreqBNKEval();
//		h.countCategories();
		h.corpusStatistics();
	}
	
	
	public void divideFreeNonfreeNondecomp(String method){
		int min = 100;
		
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK.txt";
		String outfname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK_"+min+"plus.txt";
		String outfname1 = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK_"+min+"plus_Y.txt";
		String outfname2 = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK_"+min+"plus_A.txt";

		try{
			Scanner scan = new Scanner(new File(fname), "UTF-8");
			Writer out = new OutputStreamWriter(new FileOutputStream(outfname),"UTF-8");
			Writer out1 = new OutputStreamWriter(new FileOutputStream(outfname1),"UTF-8");
			Writer out2 = new OutputStreamWriter(new FileOutputStream(outfname2),"UTF-8");


			while (scan.hasNext()) {
				String l = scan.nextLine();
				
				String[] items = l.split("\t");
				
				if (items.length<7) continue;
				
				// ignore items with frequency below a threshold
				int freq = Integer.valueOf(items[5].trim());
				if (freq<min) continue;
				
				if(items[2].trim().equals("Y")) {
					for (int i = 0; i<freq; i++) out1.write(items[6]+"\n");
				} else if(items[2].trim().equals("A") || items[2].trim().equals("B") ){
					for (int i = 0; i<freq; i++) out2.write(items[6]+"\n");
				} else {
					for (int i = 0; i<freq; i++) out.write(items[6]+"\n");
				}
			}
			
			scan.close();
			out.close();
			out1.close();
			out2.close();
		
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
	
	public void countCategories(){
		int min = 100;
		
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/LogLikelihood_NO_BNK.txt";
		HashMap<String,Integer> hm = new HashMap<String,Integer>();
		
		try{
			Scanner scan = new Scanner(new File(fname), "UTF-8");


			while (scan.hasNext()) {
				String l = scan.nextLine();
				
				String[] items = l.split("\t");
				
				if (items.length<7) continue;
				
				// ignore items with frequency below a threshold
				int freq = Integer.valueOf(items[5].trim());
				
				String s = items[2].trim();
				if (hm.containsKey(s)) hm.put(s, hm.get(s)+1);
				else hm.put(s, 1);
			}
			
			scan.close();

for(String s : hm.keySet()) {
	System.out.println(s+ "\t"+hm.get(s));
}
			
			
		} catch (IOException e) {
			e.printStackTrace();
		}

	}


	public void divideFreeNonfreeNondecompFreq(String method){
		int min = 0;
		
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK.txt";
		String outfname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK_2D_"+min+"plus.txt";
		String outfname1 = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK_2D_"+min+"plus_Y.txt";
		String outfname2 = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK_2D_"+min+"plus_A.txt";

		try{
			Scanner scan = new Scanner(new File(fname), "UTF-8");
			Writer out = new OutputStreamWriter(new FileOutputStream(outfname),"UTF-8");
			Writer out1 = new OutputStreamWriter(new FileOutputStream(outfname1),"UTF-8");
			Writer out2 = new OutputStreamWriter(new FileOutputStream(outfname2),"UTF-8");


			while (scan.hasNext()) {
				String l = scan.nextLine();
				
				String[] items = l.split("\t");
				
				if (items.length<7) continue;
				
				// ignore items with frequency below a threshold
				if (Integer.valueOf(items[5].trim())<min) continue;
				if (items[6].equals("NaN")) continue;
				
				if(items[2].trim().equals("Y")) {
					out1.write(items[5]+"\t"+items[6]+"\n");
				} else if(items[2].trim().equals("A") || items[2].trim().equals("B") ){
					out2.write(items[5]+"\t"+items[6]+"\n");
				} else {
					out.write(items[5]+"\t"+items[6]+"\n");
				}
			}
			
			scan.close();
			out.close();
			out1.close();
			out2.close();
		
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
	
	public void divideFreeNonfreeNondecompFreqBNKEval(){
		AssociationEvaluator ae = new AssociationEvaluator();
		
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/ChiSquare.txt";
//		String outfname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK_2D_"+min+"plus.txt";
//		String outfname1 = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK_2D_"+min+"plus_Y.txt";
//		String outfname2 = "/home/ivelina/svn_corpus/forTheTagger/frequencies/"+method+"_NO_BNK_2D_"+min+"plus_A.txt";

		try{
			Scanner scan = new Scanner(new File(fname), "UTF-8");
//			Writer out = new OutputStreamWriter(new FileOutputStream(outfname),"UTF-8");
//			Writer out1 = new OutputStreamWriter(new FileOutputStream(outfname1),"UTF-8");
//			Writer out2 = new OutputStreamWriter(new FileOutputStream(outfname2),"UTF-8");
//7,8,9
			int n_all_all = 2227026;

			int n_all = 0;

			int n_correct_Y = 0;
			int n_correct_MWE = 0;

			int n_all_Y = 0;
			int n_all_MWE = 0;

			int n_recognised_Y = 0;
			int n_recognised_MWE = 0;

			while (scan.hasNext()) {
				String l = scan.nextLine();
				
				String[] items = l.split("\t");
				
				if (items.length<11) continue;
				
				// ignore items with frequency below a threshold
//				if (Integer.valueOf(items[5].trim())<min) continue;
				if (items[6].equals("NaN")) continue;
				if (items[9].equals("0")) continue;
				
				int w1f = Integer.valueOf(items[7]);
				int w2f = Integer.valueOf(items[8]);
				int mwef = Integer.valueOf(items[9]);
				
				
				double ll = ae.getLogLikelihood(w1f, w2f, mwef, true);
				
				n_all ++;

				if (items[2].equals("Y")) n_all_Y ++;
				else n_all_MWE ++;
				
				if (mwef*470.0/13.0 < 2000 && (ll < 1000 || mwef < 50.0*470.0/13)) {
					n_recognised_Y ++;
					if (items[2].equals("Y"))  n_correct_Y ++;
				} else {
					n_recognised_MWE ++;
					if (!items[2].equals("Y")) n_correct_MWE ++;
				}
				
				System.out.println(items[2]+"\t"+ll);
				
			
			}
			DecimalFormat df = new DecimalFormat("#.##");
			System.out.println(n_recognised_MWE+"\t"+n_all_MWE +"\t" + n_correct_MWE);
			System.out.println((n_correct_MWE) 
//					 + "\t" + (n_all_MWE) 
					 +  "\t" + df.format(100.0*(n_correct_MWE)/(n_recognised_MWE))
					 +  "\t" + df.format(100.0*(n_correct_MWE)/(1.0*n_all_MWE))
					 +  "\t" + df.format(1.5*100.0*(n_correct_MWE)/(n_recognised_MWE)+100.0*(n_correct_MWE)/(1.0*n_all_MWE))
					 );

			scan.close();
//			out.close();
//			out1.close();
//			out2.close();
		
		} catch (IOException e) {
			e.printStackTrace();
		}

	}


	public void selectMostFreq(){
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/ChiSquare_NO_BNK.txt";

		String mostfreq = "/home/ivelina/svn_corpus/forTheTagger/frequencies/ChiSquare_NO_BNK_workingcopy_freq50up.txt";

		try{
			Scanner scan = new Scanner(new File(fname), "UTF-8");

			Writer outmostfreq = new OutputStreamWriter(new FileOutputStream(mostfreq),"UTF-8");

			while (scan.hasNext()) {
				String l = scan.nextLine();
				
				String[] items = l.split("\t");
				
				if (items.length<7) continue;
				
				if (Integer.valueOf(items[5]) >50) {
					
					outmostfreq.write(l+"\n");
					continue;
				}

			}
			
			scan.close();
			outmostfreq.close();
		
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
	
	public void selectMostFreqSorted(){
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/ChiSquare_NO_BNK.txt";

		String mostfreq = "/home/ivelina/svn_corpus/forTheTagger/frequencies/ChiSquare_NO_BNK_freq300up_sorted.txt";
		
		TreeMap<Integer,TreeMap<String,String>> hm = new TreeMap<Integer,TreeMap<String,String>>();

		try{
			Scanner scan = new Scanner(new File(fname), "UTF-8");

			Writer outmostfreq = new OutputStreamWriter(new FileOutputStream(mostfreq),"UTF-8");

			while (scan.hasNext()) {
				String l = scan.nextLine();
				
				String[] items = l.split("\t");
				
				if (items.length<7) continue;
				
				int key = Integer.valueOf(items[5]);
				if (key >300) {
					key=-key;
					if (hm.containsKey(key)) {
						hm.get(key).put(items[0].trim(), l);
					} else {
						TreeMap<String,String> h = new TreeMap<String,String>();
						h.put(items[0].trim(), l);
						hm.put(key, h);
					}
				}

			}
			
			//sorted hashmap
			for (int i : hm.keySet()){
				TreeMap<String,String> tm = (TreeMap<String,String>)hm.get(i);
				for (String key : tm.keySet()){
					outmostfreq.write(tm.get(key)+"\n");
				}
			}
	
			outmostfreq.write("\n");outmostfreq.write("\n");
			
			for (int i : hm.keySet()){
				TreeMap<String,String> tm = (TreeMap<String,String>)hm.get(i);
				for (String key : tm.keySet()){
					if(tm.get(key).contains("\t0\tY")) outmostfreq.write(tm.get(key)+"\n");
				}
			}

			scan.close();
			outmostfreq.close();
		
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
	
	public void corpusStatistics() {

		String path = "/home/ivelina/svn_corpus/forTheTagger/xml-verified-marked-plus1";

		String pathToFindDomain = "/home/ivelina/svn_corpus/forTheTagger/xml-verified-marked-plus1/bg/G-PopularScience/";

		HashMap<String, Integer> numfiles = new HashMap<String, Integer>();
		HashMap<String, Integer> numwords = new HashMap<String, Integer>();
		
	    File startingDirectory= new File(path);
	    List<File> files = null;
	    try{
	    	files = getFileListing(startingDirectory);
	    	System.out.println(files.size());
	    } catch(Exception e){
	    	System.err.println("GET listing error");
	    }

	    if (files == null) {
	    	System.err.println("Listing error "+path);
	    	System.exit(-1);
	    }

	    try{

		for(File file : files ){
		      if (file.isFile()){
		    	  
		    	  String filename = file.getAbsolutePath();
		    	  filename  = filename.substring(pathToFindDomain.length());
		    	  String domain = filename.substring(0,filename.indexOf("/"));

		    	  if (numfiles.containsKey(domain)) numfiles.put(domain, numfiles.get(domain)+1);
		    	  else numfiles.put(domain, 1);
		    	  
		    	  System.err.println(file.getAbsolutePath()+"\t"+domain+"\t"+numfiles.get(domain));
		    	  
		    	  Scanner s = new Scanner(file, "UTF-8");
		    	  
		    	  int numw = 0;
		    	  
		    	  while(s.hasNextLine()){
		    		  s.nextLine();
		    		  numw++;
		    	  }
		    	  s.close();

		    	  if (numwords.containsKey(domain)) {
		    		  numwords.put(domain, numwords.get(domain)+numw-2);
		    	  }  else {
		    		  numwords.put(domain, numw-2);
		    	  }

	    		  System.out.println(file.getAbsolutePath()+"\t"+domain+"\t"+numwords.get(domain));
		    	  
		      }
		}
		
		int allf = 0;
		int allw = 0;
		for (String key : numfiles.keySet()) {
			System.out.println(
					  key 
					+ "\t" + key
					+ "\t" + numfiles.get(key)
					+ "\t" + (numwords.containsKey(key) ? numwords.get(key) : "N/A")
			);
			allf = allf + numfiles.get(key);
			allw = allw + (numwords.containsKey(key) ? numwords.get(key) : 0);
		}
		System.out.println(
				  "Общо" 
				+ "\t" + ""
				+ "\t" + allf
				+ "\t" + allw
		);
		
	    } catch(Exception e){
	    	e.printStackTrace();
	    }
	}

	  /**
	   * Recursively walk a directory tree and return a List of all
	   * Files found; the List is sorted using File.compareTo().
	   *
	   * @param aStartingDir is a valid directory, which can be read.
	   */
	   static public List<File> getFileListing(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     validateDirectory(aStartingDir);
	     List<File> result = getFileListingNoSort(aStartingDir);
	     Collections.sort(result);
	     return result;
	   }

	   // PRIVATE //
	   static private List<File> getFileListingNoSort(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     List<File> result = new ArrayList<File>();
	     File[] filesAndDirs = aStartingDir.listFiles();
	     List<File> filesDirs = Arrays.asList(filesAndDirs);
	     for(File file : filesDirs) {
	       result.add(file); //always add, even if directory
	       if ( ! file.isFile() ) {
	         //must be a directory
	         //recursive call!
	         List<File> deeperList = getFileListingNoSort(file);
	         result.addAll(deeperList);
	       }
	     }
	     return result;
	   }

	   /**
	   * Directory is valid if it exists, does not represent a file, and can be read.
	   */
	   static private void validateDirectory (
	     File aDirectory
	   ) throws FileNotFoundException {
	     if (aDirectory == null) {
	       throw new IllegalArgumentException("Directory should not be null.");
	     }
	     if (!aDirectory.exists()) {
	       throw new FileNotFoundException("Directory does not exist: " + aDirectory);
	     }
	     if (!aDirectory.isDirectory()) {
	       throw new IllegalArgumentException("Is not a directory: " + aDirectory);
	     }
	     if (!aDirectory.canRead()) {
	       throw new IllegalArgumentException("Directory cannot be read: " + aDirectory);
	     }
	   }



	
}
