package bg.bas.dcl.CorpusTools;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.text.DecimalFormat;
import java.util.Scanner;

public class ResultsEvaluator {
	
	public static String mainPath = "";

	public static void main(String[] args){
		
		mainPath = args[0];

		ResultsEvaluator re = new ResultsEvaluator();
//		re.evaluateMethod1(258317); // chi square
		
//		re.evaluateMethod1(176.1252); // log-likelihood
		
//		re.evaluateMethodAdd(5,10,0.2);

//		re.evaluateMethodCombined(5,10,0.2,619960.8); // second chi2
		
		for (int h = 100; h>50; h = h-10){
			int l=50;//for (int l = 10; l < 101; l=l+5)
			for (int s=1; s < 6; s++)
				re.evaluateMethodCombined(s,6,1,l,h); // second method LL
		}
	}

	
	public void evaluateMethod1(double measureLimit1){
		String fname = mainPath + "/frequencies/ChiSquare_NO_BNK.txt";
		
		
		for (double d = 0.2; d<5; d=d+0.2) {
			double measureLimit = measureLimit1*d;
			
			int n_all_all = 2227026;

			int n_all = 0;

			int n_correct_Y = 0;
			int n_correct_MWE = 0;

			int n_all_Y = 0;
			int n_all_MWE = 0;

			int n_recognised_Y = 0;
			int n_recognised_MWE = 0;

			
			try{
				Scanner scan = new Scanner(new File(fname), "UTF-8");
	
				while (scan.hasNext()) {
					String l = scan.nextLine();
					
					String[] items = l.split("\t");
					
					if (items.length<7) continue;
					
					// get item, make it double, compare with limit
					double measure = Double.valueOf(items[6]);
					int freq = 1;//Integer.valueOf(items[5]);
					
					n_all += freq;
	
					if (items[2].equals("Y")) n_all_Y += freq;
					else n_all_MWE += freq;
					
					if (measure < measureLimit) {
						n_recognised_Y += freq;
						if (items[2].equals("Y"))  n_correct_Y += freq;
					} else {
						n_recognised_MWE += freq;
						if (!items[2].equals("Y")) n_correct_MWE += freq;
					}
				}
				
				DecimalFormat df = new DecimalFormat("#.##");
				
				System.out.println(df.format(measureLimit)
										 + "\t" + (n_correct_MWE) 
//										 + "\t" + (n_all_MWE) 
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(n_recognised_MWE))
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(1.0*n_all_MWE))
										 );
	
				/**
				System.out.println("SLE" + "\t" + (n_correct_SLE) 
										 + "\t" + (n_all_SLE) 
										 +  "\t" + 1.0*(n_correct_SLE)/(1.0*n_recognised_SLE)
										 +  "\t" + "-"//1.0*(n_correct_SLE)/(1.0*n_all_SLE)
										 );
				System.out.println("non-SLE" + "\t" + (n_correct_A) 
										     + "\t" + (n_all_A) 
										     +  "\t" + 1.0*(n_correct_A)/(1.0*n_recognised_A)
										     +  "\t" + "-"//1.0*(n_correct_A)/(1.0*n_all_A)
										     );
										     
				
				System.out.println("Y" + "\t" + measureLimit
						 + "\t" + (n_correct_Y) 
					     + "\t" + (n_all_Y) 
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_recognised_Y))
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_all_Y))
					     );
				
				*/
			
				scan.close();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
		}
	}
	
	public void evaluateMethodAdd(double from, double to, double step){
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/MutualInformation_NO_BNK.txt";
		
		
		for (double d = from; d<to; d=d+step) {
			double measureLimit = d;
			
			int n_all_all = 2227026;

			int n_all = 0;

			int n_correct_Y = 0;
			int n_correct_MWE = 0;

			int n_all_Y = 0;
			int n_all_MWE = 0;

			int n_recognised_Y = 0;
			int n_recognised_MWE = 0;

			
			try{
				Scanner scan = new Scanner(new File(fname), "UTF-8");
	
				while (scan.hasNext()) {
					String l = scan.nextLine();
					
					String[] items = l.split("\t");
					
					if (items.length<7) continue;
					
					// get item, make it double, compare with limit
					double measure = Double.valueOf(items[6]);
					int freq = 1;//Integer.valueOf(items[5]);
					
					n_all += freq;
	
					if (items[2].equals("Y")) n_all_Y += freq;
					else n_all_MWE += freq;
					
					if (measure < measureLimit) {
						n_recognised_Y += freq;
						if (items[2].equals("Y"))  n_correct_Y += freq;
					} else {
						n_recognised_MWE += freq;
						if (!items[2].equals("Y")) n_correct_MWE += freq;
					}
				}
				
				DecimalFormat df = new DecimalFormat("#.##");
				
				System.out.println(df.format(measureLimit)
										 + "\t" + (n_correct_MWE) 
//										 + "\t" + (n_all_MWE) 
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(n_recognised_MWE))
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(1.0*n_all_MWE))
										 );
	
				/**
				System.out.println("SLE" + "\t" + (n_correct_SLE) 
										 + "\t" + (n_all_SLE) 
										 +  "\t" + 1.0*(n_correct_SLE)/(1.0*n_recognised_SLE)
										 +  "\t" + "-"//1.0*(n_correct_SLE)/(1.0*n_all_SLE)
										 );
				System.out.println("non-SLE" + "\t" + (n_correct_A) 
										     + "\t" + (n_all_A) 
										     +  "\t" + 1.0*(n_correct_A)/(1.0*n_recognised_A)
										     +  "\t" + "-"//1.0*(n_correct_A)/(1.0*n_all_A)
										     );
										     
				
				System.out.println("Y" + "\t" + measureLimit
						 + "\t" + (n_correct_Y) 
					     + "\t" + (n_all_Y) 
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_recognised_Y))
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_all_Y))
					     );
				
				*/
			
				scan.close();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
		}
	}

	
	public void evaluateMethodCombined(double from, double to, double step, int lowfreq, int highfreq){
//		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/EnhancedMutualInformation_NO_BNK.txt";
//		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/ChiSquare_NO_BNK.txt";
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/LogLikelihood_NO_BNK.txt";
			
		for (double d = from; d<to; d=d+step) {

//			double measureLimit = d;
			
			int n_all_all = 2227026;

			int n_all = 0;

			int n_correct_Y = 0;
			int n_correct_MWE = 0;

			int n_all_Y = 0;
			int n_all_MWE = 0;

			int n_recognised_Y = 0;
			int n_recognised_MWE = 0;

			
			try{
				Scanner scan = new Scanner(new File(fname), "UTF-8");
	
				while (scan.hasNext()) {
					String l = scan.nextLine();
					
					String[] items = l.split("\t");
					
					if (items.length<7) continue;
					
					// get item, make it double, compare with limit
					double measure = Double.valueOf(items[6]);

					int freq = Integer.valueOf(items[5]);
					
					n_all ++;
	
					if (items[2].equals("Y")) n_all_Y ++;
					else n_all_MWE ++;
					
					if (freq < highfreq && (measure < d || freq < lowfreq)) {
						n_recognised_Y ++;
						if (items[2].equals("Y"))  n_correct_Y ++;
					} else {
						n_recognised_MWE ++;
						if (!items[2].equals("Y")) n_correct_MWE ++;
					}
				}
				
				DecimalFormat df = new DecimalFormat("#.##");
				
				System.out.println(lowfreq + "\t" + highfreq
										 + "\t" + df.format(d)
										 + "\t" + (n_correct_MWE) 
//										 + "\t" + (n_all_MWE) 
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(n_recognised_MWE))
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(1.0*n_all_MWE))
										 +  "\t" + df.format(1.5*100.0*(n_correct_MWE)/(n_recognised_MWE)+100.0*(n_correct_MWE)/(1.0*n_all_MWE))
										 );
	
				/**
				System.out.println("SLE" + "\t" + (n_correct_SLE) 
								551114\\		 + "\t" + (n_all_SLE) 
										 +  "\t" + 1.0*(n_correct_SLE)/(1.0*n_recognised_SLE)
										 +  "\t" + "-"//1.0*(n_correct_SLE)/(1.0*n_all_SLE)
										 );
				System.out.println("non-SLE" + "\t" + (n_correct_A) 
										     + "\t" + (n_all_A) 
										     +  "\t" + 1.0*(n_correct_A)/(1.0*n_recognised_A)
										     +  "\t" + "-"//1.0*(n_correct_A)/(1.0*n_all_A)
										     );
										     
				
				System.out.println("Y" + "\t" + measureLimit
						 + "\t" + (n_correct_Y) 
					     + "\t" + (n_all_Y) 
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_recognised_Y))
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_all_Y))
					     );
				
				*/
			
				scan.close();
			
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
		}

	}

	public void evaluateMethodCombinedBNK(double from, double to, double step, int lowfreq, int highfreq){
//		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/EnhancedMutualInformation_NO_BNK.txt";
//		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/ChiSquare_NO_BNK.txt";
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/LogLikelihood_NO_BNK.txt";
			
		for (double d = from; d<to; d=d+step) {

//			double measureLimit = d;
			
			int n_all_all = 2227026;

			int n_all = 0;

			int n_correct_Y = 0;
			int n_correct_MWE = 0;

			int n_all_Y = 0;
			int n_all_MWE = 0;

			int n_recognised_Y = 0;
			int n_recognised_MWE = 0;

			
			try{
				Scanner scan = new Scanner(new File(fname), "UTF-8");
	
				while (scan.hasNext()) {
					String l = scan.nextLine();
					
					String[] items = l.split("\t");
					
					if (items.length<7) continue;
					
					// get item, make it double, compare with limit
					double measure = Double.valueOf(items[6]);

					int freq = Integer.valueOf(items[5]);
					
					n_all ++;
	
					if (items[2].equals("Y")) n_all_Y ++;
					else n_all_MWE ++;
					
					if (freq < highfreq && (measure < d || freq < lowfreq)) {
						n_recognised_Y ++;
						if (items[2].equals("Y"))  n_correct_Y ++;
					} else {
						n_recognised_MWE ++;
						if (!items[2].equals("Y")) n_correct_MWE ++;
					}
				}
				
				DecimalFormat df = new DecimalFormat("#.##");
				
				System.out.println(lowfreq + "\t" + highfreq
										 + "\t" + df.format(d)
										 + "\t" + (n_correct_MWE) 
//										 + "\t" + (n_all_MWE) 
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(n_recognised_MWE))
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(1.0*n_all_MWE))
										 +  "\t" + df.format(1.5*100.0*(n_correct_MWE)/(n_recognised_MWE)+100.0*(n_correct_MWE)/(1.0*n_all_MWE))
										 );
	
				/**
				System.out.println("SLE" + "\t" + (n_correct_SLE) 
								551114\\		 + "\t" + (n_all_SLE) 
										 +  "\t" + 1.0*(n_correct_SLE)/(1.0*n_recognised_SLE)
										 +  "\t" + "-"//1.0*(n_correct_SLE)/(1.0*n_all_SLE)
										 );
				System.out.println("non-SLE" + "\t" + (n_correct_A) 
										     + "\t" + (n_all_A) 
										     +  "\t" + 1.0*(n_correct_A)/(1.0*n_recognised_A)
										     +  "\t" + "-"//1.0*(n_correct_A)/(1.0*n_all_A)
										     );
										     
				
				System.out.println("Y" + "\t" + measureLimit
						 + "\t" + (n_correct_Y) 
					     + "\t" + (n_all_Y) 
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_recognised_Y))
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_all_Y))
					     );
				
				*/
			
				scan.close();
			
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
		}

	}

	
	
	public void evaluateMethodAddOverThreshold(double from, double to, double step){
		String fname = "/home/ivelina/svn_corpus/forTheTagger/frequencies/MutualInformation_NO_BNK.txt";
		
		int thres = 0;
		
		for (double d = from; d<to; d=d+step) {
			double measureLimit = d;
			
			int n_all_all = 2227026;

			int n_all = 0;

			int n_correct_Y = 0;
			int n_correct_MWE = 0;

			int n_all_Y = 0;
			int n_all_MWE = 0;

			int n_recognised_Y = 0;
			int n_recognised_MWE = 0;

			
			try{
				Scanner scan = new Scanner(new File(fname), "UTF-8");
	
				while (scan.hasNext()) {
					String l = scan.nextLine();
					
					String[] items = l.split("\t");
					
					if (items.length<7) continue;
					
					// get item, make it double, compare with limit
					double measure = Double.valueOf(items[6]);
					int freq = 1;//
					
					int f = Integer.valueOf(items[5]);
					
					n_all += freq;
	
					if (items[2].equals("Y")) n_all_Y += freq;
					else n_all_MWE += freq;
					
					if (f>thres) {
						if (measure < measureLimit) {
							n_recognised_Y += freq;
							if (items[2].equals("Y"))  n_correct_Y += freq;
						} else {
							n_recognised_MWE += freq;
							if (!items[2].equals("Y")) n_correct_MWE += freq;
						}
					}
				}
				
				DecimalFormat df = new DecimalFormat("#.##");
				
				System.out.println(df.format(measureLimit)
										 + "\t" + (n_correct_MWE) 
//										 + "\t" + (n_all_MWE) 
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(n_recognised_MWE))
										 +  "\t" + df.format(100.0*(n_correct_MWE)/(1.0*n_all_MWE))
										 );
	
				/**
				System.out.println("SLE" + "\t" + (n_correct_SLE) 
										 + "\t" + (n_all_SLE) 
										 +  "\t" + 1.0*(n_correct_SLE)/(1.0*n_recognised_SLE)
										 +  "\t" + "-"//1.0*(n_correct_SLE)/(1.0*n_all_SLE)
										 );
				System.out.println("non-SLE" + "\t" + (n_correct_A) 
										     + "\t" + (n_all_A) 
										     +  "\t" + 1.0*(n_correct_A)/(1.0*n_recognised_A)
										     +  "\t" + "-"//1.0*(n_correct_A)/(1.0*n_all_A)
										     );
										     
				
				System.out.println("Y" + "\t" + measureLimit
						 + "\t" + (n_correct_Y) 
					     + "\t" + (n_all_Y) 
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_recognised_Y))
					     +  "\t" + df.format(100.0*(n_correct_Y)/(1.0*n_all_Y))
					     );
				
				*/
			
				scan.close();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
		}
	}

}
