package bg.bas.dcl.CorpusTools;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import bg.bas.dcl.mwe.entities.Word;
import bg.bas.dcl.mwe.lists.IndexLexicon;
import bg.bas.dcl.mwe.lists.TokenToLemmaLexicon;

public class TaggedToXMLConverter {

	static ArrayList<Integer> tokenFrequencyCtr = new ArrayList<Integer>();
	static ArrayList<Integer> lemmaFrequencyCtr = new ArrayList<Integer>();

	static public IndexLexicon tokenLexicon = new IndexLexicon(
			tokenFrequencyCtr);
	static public IndexLexicon lemmaLexicon = new IndexLexicon(
			lemmaFrequencyCtr);

	static TokenToLemmaLexicon tokenToLemmaLexicon = new TokenToLemmaLexicon();

	static long chunkctr = 1;
	static long mwectr = 1;
	static String punct = ".,?!;\"&(){}[]-<>";
	static ArrayList<String> langs = new ArrayList<String>();
	static HashMap<String,Record> records = new HashMap<String,Record>();

	
	static boolean isSymmetric(String flag) {
		for (int i = 0; i< flag.length()/2; i++) {
			if (!flag.substring(i,i+1).equals(flag.substring(flag.length()-i-1))) return false;
		}
		return true;
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		// args: langs, records
		
		readLangs("/home/ivelina/CORPORA/resources/langs-wikipedia.txt");
		readRecords("/home/ivelina/svn_corpus/forTheTagger/corpus_data.txt");
		System.out.println(records.size());

		String pathOriginal = args[0];
		String pathTagged = args[1];
		String outpath = args[2];

		File startingDirectory = new File(pathOriginal);
		List<File> files = null;
		try {
			files = getFileListing(startingDirectory);
			System.out.println(files.size());
		} catch (Exception e) {
			System.err.println("GET listing error");
		}

		if (files == null) {
			System.err.println("Listing error " + pathTagged);
			System.exit(-1);
		}

		try {
			Writer mwes = new OutputStreamWriter(new FileOutputStream(args[3]),
			"UTF-8");
			Writer log = new OutputStreamWriter(new FileOutputStream(args[4]),
					"UTF-8");
			Writer translated = new OutputStreamWriter(new FileOutputStream(args[5]),
			"UTF-8");

			fileloop: for (File file : files) {
				if (file.isFile()) {

					if (file.getName().startsWith("._"))
						continue;
					if (file.getName().endsWith("~"))
						continue;

					String filename = file.getAbsolutePath();

					String taggedname = pathTagged
							+ filename.substring(pathOriginal.length());
					String toname = outpath
							+ filename.substring(pathOriginal.length());

					try {

						File to = new File(toname);
						makeParent(toname, outpath);
						log.write(file.getAbsolutePath() + "\n");
						log.flush();
						// System.err.println(to.getAbsolutePath());

						Scanner s = new Scanner(file, "UTF-8");
						Scanner st = new Scanner(new File(taggedname), "UTF-8");

						Writer out = new OutputStreamWriter(
								new FileOutputStream(toname), "UTF-8");
						out.write("<?xml version=\"1.0\" ?><text current=\"0\">");
						out.flush();

						String flag = "";
						String flaggedWord = "", content = "";

		lineloop:       while (s.hasNextLine()) {
							String line = s.nextLine();
							line = line.replaceAll(" по- ", " по-");
							line = line.replaceAll(" най- ", " най-");
							line = line.replaceAll(" По- ", " По-");
							line = line.replaceAll(" Най- ", " Най-");

							String[] words = line.split("[ \t]");

//							log.write(line + "\nNum words: " + words.length
//									+ "\n");
//							log.flush();

							chunkctr++;

							String l = "";

				wordloop:   for (int i = 0; i < words.length; i++) {

								String word = words[i].trim();

//								log.write("word: " + word + "\n");
//								log.flush();

								if (word.equals(""))
									continue;

								// System.err.println("Words " + words.length +
								// " READ " + word);
								String tempword = "";
								String[] info;

								if (word.contains("http")) {
									// skip that word

									// but synchronise with the tagged file
									String t = "";

									while (word.contains(t) && st.hasNext()) {
										l = st.nextLine();

										if (!t.equals("") && word.startsWith(t)) {
											word = word.substring(word
													.indexOf(t) + t.length());
											t = "";
										}

										t += (l.split("\t"))[0].trim();

//										log.write(word + " contains " + t
//												+ "?\n");
//										log.flush();

									}

									continue wordloop;
								}

								// log.write("last line: " + l+ "\n");
								// log.flush();

			allpiecesloop:     while (tempword.length() < word
										.length()) {

									if (st.hasNext() && l.equals(""))
										l = st.nextLine();
									else if (!st.hasNext()) {
										System.err
												.println("End of tagged file");
										out.write("</text>");
										out.flush();
										out.close();
										continue fileloop;
										// System.exit(0);
									}

									info = l.split("[ \t]");

									info[0] = info[0].trim();
																		
									tempword += info[0].trim();
									
									if(info[2].equals("M")) {
										while (info[0].length()>0) {
											String pre="";
											int ii=0;
											for (ii = 0; ii<info[0].length(); ii++) {
												if (punct.contains(info[0].substring(ii,ii+1))) break;
											}
											pre = info[0].substring(0,ii);
											System.out.println(info[0]+"\t"+pre);
											
											if (pre.length()>0) {
												flaggedWord += pre+"\t"+ pre+"\tM\n";
												info[0] = info[0].substring(ii);
											}
											if (info[0].length()>0) {
												flaggedWord += info[0].substring(0,1)+"\t"+ info[0].substring(0,1)+"\tU\n";
												info[0] = info[0].substring(1);
											}
										}

//										log.write("flag: " + flag + " word: "
//												+ word + "\t" + "temp: " + tempword
//												+ "\n");
//										log.flush();
									} else {
										
										flaggedWord += l + "\n";
//										log.write("flag: " + flag + " word: "
//												+ word + "\t" + "temp: " + tempword
//												+ "\n");
//										log.flush();

									}

									l = "";
								}

								
								if (word.equals(tempword)) {


									String[] flaggedWordLines1 = flaggedWord
											.split("\n");
									

									for (String flaggedLine : flaggedWordLines1) {


										String[] flaggedWordInfo = flaggedLine
												.split("\t");

										if (flaggedWordInfo[0].trim()
												.equals(""))
											continue;
										

										if (word.startsWith("{{")
												|| word.startsWith("[[")) {
											flag += word.substring(0, 2);
										}

										if (word.startsWith("}}")) {
											if (flag.equals("{{")) flag += word.substring(0, 2);
											else if (flag.endsWith("{{")) flag = flag.substring(0,flag.length()-2);
										}
										if (word.startsWith("]]")) {
											if (flag.equals("[[")) flag += word.substring(0, 2);
											else if (flag.endsWith("[[")) flag = flag.substring(0,flag.length()-2);
										}
							
										if (word.startsWith(")}}")) {
											if (flag.equals("{{")) flag += word.substring(1, 3);
											else if (flag.endsWith("{{")) flag = flag.substring(0,flag.length()-2);
										}
										if (word.startsWith(")]]")) {
											if (flag.equals("[[")) flag += word.substring(1, 3);
											else if (flag.endsWith("[[")) flag = flag.substring(0,flag.length()-2);
										}

//										log.write("Flag: " + flag
//												+ " Process word: " + word
//												+ " piece: "
//												+ flaggedWordInfo[0] + "\n");
//										log.flush();

										if (word.startsWith(flaggedWordInfo[0])) {

											if (flag.equals("")) {
												Word w = new Word(tokenLexicon,
														lemmaLexicon);
												w.word = tokenLexicon
														.addEntry(flaggedWordInfo[0]);
												w.lemma = lemmaLexicon
														.addEntry(flaggedWordInfo[1]);

												w.sen = String
														.valueOf(chunkctr);
												w.pos = flaggedWordInfo[2];

												if (flaggedWordInfo[2]
														.equals("U"))
													chunkctr++;

												word = word
														.substring(flaggedWordInfo[0]
																.length());

												out.write(w.toXML());
												out.flush();
											} else {
												word = word
														.substring(flaggedWordInfo[0]
																.length());
												content += flaggedLine + "\n";

											}

										}

									}
									if (flag.equals("")) {
										flaggedWord = "";
										continue wordloop;
									}

									if ((flag.endsWith("[["))
											|| (flag.endsWith("{{"))) {
										
										flaggedWord = "";
										continue wordloop;
									}

//									log.write("***\n" + content
//											+ "\n**********\n");
//									log.flush();

									if ((flag.endsWith("]]"))
											|| (flag.endsWith("}}"))) {

										// TODO separate list
										if (flag.startsWith("[[")
												&& (content
														.contains("Категория")
														|| content
																.contains("Файл") || content
															.contains("Шаблон") || content
															.contains("Картинка"))
												&& content.contains(":")) {

//											log.write("REMOVED\n");
//											log.flush();

											flaggedWord = "";
											flag = "";
											content = "";
											continue lineloop;
										}

										if (flag.startsWith("{{")) {

//											log.write("REMOVED\n");
//											log.flush();

											flaggedWord = "";
											flag = "";
											content = "";
											continue lineloop;
										}

										String flaggedWord1 = "";
										String flaggedWord2 = "";
										String flaggedWord3 = "";

										int ii = 0, jj = 0;
										if (content.contains("|")) {
											ii = content.indexOf("|");
											int jj_b = content.substring(0,ii)
													.lastIndexOf("\n");
											jj = ii
													+ content.substring(ii)
															.indexOf("\n");
											flaggedWord1 = content
													.substring(0, jj_b);
											
											String[] w12 = (content.substring(jj_b+1,jj-1).split("\t"))[0].split("\\|");
//											log.write("Separate words "+content.substring(jj_b+1,jj-1)+" length: "+w12.length+"\n");
											if (w12.length >0) {
//												log.write("Separate words "+w12[0]+"\t"+
//														w12[0]+"\n");
												flaggedWord1 += "\n"+w12[0]+"\t"+w12[0]+"\t"+"M\n";
												if (w12.length >1) flaggedWord2 += "\n"+w12[1]+"\t"+w12[1]+"\t"+"M\n";
											}
											
	//										flaggedWord2 += content.substring(jj + 1);
										} else {
	//										flaggedWord2 = content;
										}
	

										int ii2 = content.lastIndexOf(flag
												.charAt(flag.length() - 1));

										int jj2;

										if (content.contains("\n")) {
											jj2 = ii2
													+ content
															.substring(ii2)
															.indexOf("\n");
										}	else{
											jj2 = content.length();
										}
										
										flaggedWord2 += content.substring(
												jj, jj2);
										flaggedWord3 = content
												.substring(jj2);

										System.out.println(flaggedWord1
												+ "\nDIV\n" + flaggedWord2
												+ "\nDIV\n" + flaggedWord3
												+ "\nDIV***");

//										log.write(flaggedWord1
//												+ "\n*DIV*\n" + flaggedWord2
//												+ "\n**DIV**\n" + flaggedWord3
//												+ "\n***DIV***\n");
//										log.flush();

										content = "";
										
										if (flag.startsWith("{")
												&& flaggedWord2.contains("=")) {
											flaggedWord = "";
											flag = "";
											continue lineloop;
										}
// compose mwes - main form
										String[] flaggedWordLinesMain = flaggedWord1
														.split("\n");
										int mwelength = 0;
										String mwe_main = "", mwe_form="";
										for (int n = 0; n < flaggedWordLinesMain.length; n++) {
											
											String flaggedLine = flaggedWordLinesMain[n];
											
											flaggedLine = flaggedLine
													.replaceAll("\\|", "");
											flaggedLine = flaggedLine
													.replaceAll("\\[", "");
											flaggedLine = flaggedLine
													.replaceAll("\\]", "");
											flaggedLine = flaggedLine
													.replaceAll("\\{", "");
											flaggedLine = flaggedLine
													.replaceAll("\\}", "");
											flaggedLine = flaggedLine
													.replaceAll("'''", "");

											String[] flaggedWordInfo = flaggedLine
											.split("\t");

											if (flaggedWordInfo[0].trim()
													.equals(""))
												continue;

											mwelength ++;
											mwe_main += flaggedWordInfo[0].trim()+" ";
										}

// compose mwes - word form										
										String[] flaggedWordLines = flaggedWord2
												.split("\n");

										ArrayList<Word> result = new ArrayList<Word>();
										int part = 0, punctctr = 0;
										for (int n = 0; n < flaggedWordLines.length; n++) {

											String flaggedLine = flaggedWordLines[n];

											flaggedLine = flaggedLine
													.replaceAll("\\|", "");
											flaggedLine = flaggedLine
													.replaceAll("\\[", "");
											flaggedLine = flaggedLine
													.replaceAll("\\]", "");
											flaggedLine = flaggedLine
													.replaceAll("\\{", "");
											flaggedLine = flaggedLine
													.replaceAll("\\}", "");
											flaggedLine = flaggedLine
													.replaceAll("'''", "");

											String[] flaggedWordInfo = flaggedLine
													.split("\t");

											if (flaggedWordInfo[0].trim()
													.equals(""))
												continue;

											// if
											// (flaggedWordInfo[0].trim().equals("|"))
											// continue;

											mwe_form += flaggedWordInfo[0].trim()+" ";
											Word w = new Word(tokenLexicon,
													lemmaLexicon);
											w.word = tokenLexicon
													.addEntry(flaggedWordInfo[0]);
											w.lemma = lemmaLexicon
													.addEntry(flaggedWordInfo[1]);
											w.sen = String.valueOf(chunkctr);
											w.pos = flaggedWordInfo[2];

											if (flaggedWordInfo[0].trim()
													.equals("„"))
												w.pos = "U";
											if (flaggedWordInfo[0].trim()
													.equals(";"))
												w.pos = "U";
											if (w.pos.equals("U"))
												punctctr++;
											result.add(w);

										}
										
										
										String lang = ""; 
										if (mwe_form.contains(":")) {
											lang = mwe_form.substring(0,mwe_form.indexOf(":")).trim();
										}
										
										if (langs.contains(lang)) {
											translated.write(records.get(file.getName()).getAttribute("title") + "\t" + lang + "\t" + mwe_form.substring(mwe_form.indexOf(":")+1).trim()+"\n");
											translated.flush();
											mwe_form = ""; 
											mwe_main = "";
										}

										if (mwelength > 1 || result.size() - punctctr > 1) {
											if (mwe_main.trim().equals("")) mwe_main = mwe_form;
											mwes.write(mwe_main+"\t"+mwe_form+"\n");
											mwes.flush();
										}

										if (!langs.contains(lang) && result.size() - punctctr > 1) {
											for (int q = 0; q < result.size(); q++) {
												Word w = result.get(q);

												w.mwe = mwectr + ":"
															+ (part++);
												result.set(q, w);
												// if (part > 10)
												// System.exit(-1);
											}
										}
										if (result.get(result.size() - 1).mwe != null)
											mwectr++;

										flaggedWordLines = flaggedWord3
												.split("\n");

										for (int n = 0; n < flaggedWordLines.length; n++) {

											String flaggedLine = flaggedWordLines[n];

											String[] flaggedWordInfo = flaggedLine
													.split("\t");

											if (flaggedWordInfo[0].trim()
													.equals(""))
												continue;

											if (!flaggedWordInfo[2].trim()
													.equals("U")) {
												// change previous
												Word w = result.get(result
														.size() - 1);
												w.word = tokenLexicon
														.changeEntry(
																w.word,
																tokenLexicon
																		.get(w.word)
																		+ flaggedWordInfo[0]);

												result.set(result.size() - 1, w);

											} else {
												// new
												Word w = new Word(tokenLexicon,
														lemmaLexicon);
												w.word = tokenLexicon
														.addEntry(flaggedWordInfo[0]);
												w.lemma = lemmaLexicon
														.addEntry(flaggedWordInfo[1]);
												w.sen = String
														.valueOf(chunkctr++);
												w.pos = flaggedWordInfo[2];

												result.add(w);
											}
										}
										flaggedWord = "";
										flag = "";

										for (Word wo : result) {
											if (wo.word > -1)
												out.write(wo.toXML());
											out.flush();
										}

									}

								} else {

//									out.write("</text>");
									out.flush();

									log.write("File abrupted");
									log.flush();

									// rare case
									// System.exit(-1);
								}

							} // end for word
						} // end scanner s readline loop
						s.close();
						st.close();

						out.write("</text>");
						out.flush();
						out.close();

						log.write("CORRECT" + file.getAbsolutePath()
								+ "\nTokens: " + tokenLexicon.size()
								+ ", Lemmas: " + lemmaLexicon.size());
						log.flush();

					} catch (Exception e) {
						e.printStackTrace();

					}
					// System.exit(-1);
				}
			}
			log.write("\nTokens: " + tokenLexicon.size()
					+ ", Lemmas: " + lemmaLexicon.size());
			log.flush();
			log.flush();
			log.close();
			
			translated.flush();
			translated.close();
			
			mwes.flush();
			mwes.close();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {

		}
	}
	
	static void readLangs(String filename){
		
		try{
			BufferedReader inData = new BufferedReader(new FileReader(filename));
			
			while (inData.ready()){
				String line = inData.readLine();
				line = line.trim();	
				
				if (!line.equalsIgnoreCase("")) langs.add(line);
			
			}
			
			inData.close();
			
			System.out.println(langs.size());
			
		} catch (FileNotFoundException fnfe) {
			System.err.println(fnfe.getMessage());
		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		}
	}

	static void readRecords(String filename){
		
		try{
			BufferedReader inData = new BufferedReader(new FileReader(filename));
			
			while (inData.ready()){
				String line = inData.readLine();
				line = line.trim();	
				Record rec = new Record();
				rec = rec.readRecord(line);
				
				String key = rec.getAttribute("filename").substring(rec.getAttribute("filename").lastIndexOf("/")+1);
				if (!line.equalsIgnoreCase("")) records.put(key,rec);
			
			}
			
			inData.close();
			
		} catch (FileNotFoundException fnfe) {
			System.err.println(fnfe.getMessage());
		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		}
	}

	/**
	 * Recursively walk a directory tree and return a List of all Files found;
	 * the List is sorted using File.compareTo().
	 * 
	 * @param aStartingDir
	 *            is a valid directory, which can be read.
	 */
	static public List<File> getFileListing(File aStartingDir)
			throws FileNotFoundException {
		validateDirectory(aStartingDir);
		List<File> result = getFileListingNoSort(aStartingDir);
		Collections.sort(result);
		return result;
	}

	// PRIVATE //
	static private List<File> getFileListingNoSort(File aStartingDir)
			throws FileNotFoundException {
		List<File> result = new ArrayList<File>();
		File[] filesAndDirs = aStartingDir.listFiles();
		List<File> filesDirs = Arrays.asList(filesAndDirs);
		for (File file : filesDirs) {
			result.add(file); // always add, even if directory
			if (!file.isFile()) {
				// must be a directory
				// recursive call!
				List<File> deeperList = getFileListingNoSort(file);
				result.addAll(deeperList);
			}
		}
		return result;
	}

	/**
	 * Directory is valid if it exists, does not represent a file, and can be
	 * read.
	 */
	static private void validateDirectory(File aDirectory)
			throws FileNotFoundException {
		if (aDirectory == null) {
			throw new IllegalArgumentException("Directory should not be null.");
		}
		if (!aDirectory.exists()) {
			throw new FileNotFoundException("Directory does not exist: "
					+ aDirectory);
		}
		if (!aDirectory.isDirectory()) {
			throw new IllegalArgumentException("Is not a directory: "
					+ aDirectory);
		}
		if (!aDirectory.canRead()) {
			throw new IllegalArgumentException("Directory cannot be read: "
					+ aDirectory);
		}
	}

	static void makeParent(String path, String mainPath) {
		String parent = (new File(path)).getParent();

		if ((new File(parent)).exists())
			return;

		if (!parent.equals(mainPath)) {
			makeParent(parent, mainPath);
		}

		(new File(parent)).mkdir();

	}

}
