package bg.bas.dcl.LexiconTools;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;
import java.util.TreeSet;

public class TaggedDictionaryReader {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		// read filenames in; not hardcoded
		String infname = "/home/ivelina/svn_corpus/forTheTagger/lexicon/mwes_from_wiki_raw_tagged";
		String outfname = "/home/ivelina/svn_corpus/forTheTagger/lexicon/mwes_from_wiki_synt_filter";
		String outfdname = "/home/ivelina/svn_corpus/forTheTagger/lexicon/mwes_from_wiki_synt_filter_mainform";
		
		ArrayList<String> synt_patterns = new ArrayList<String>();
		synt_patterns.add("NN");
		synt_patterns.add("ANN");
		synt_patterns.add("AN");
		synt_patterns.add("AAN");
		synt_patterns.add("AAAN");
		synt_patterns.add("NRN");
		synt_patterns.add("NRAN");
		synt_patterns.add("ANRN");
		synt_patterns.add("AANRN");
		synt_patterns.add("ANRAN");

		try{
			Scanner sc = new Scanner(new File(infname), "UTF-8");
			Writer wr = new OutputStreamWriter(new FileOutputStream(outfname), "UTF-8");
			Writer wrfd = new OutputStreamWriter(new FileOutputStream(outfdname), "UTF-8");
			
			HashMap<String,ArrayList<String>> dictionary = new HashMap<String,ArrayList<String>>();
			
			ArrayList<String> entry = new ArrayList<String>();
			String w = "";
			String synt = "";

			HashMap<String,ArrayList<String>> dictionaryfd = new HashMap<String,ArrayList<String>>();
			
			ArrayList<String> entryfd = new ArrayList<String>();
			String wfd = "";

			boolean openbracket = false;
			
			while(sc.hasNextLine()) {
				String l = sc.nextLine().trim();
				String[] w_info = l.split("\t");
				if (w_info.length < 1) continue;
				w_info[0] = w_info[0].toLowerCase();
				w_info[1] = w_info[1].toLowerCase();

				
				if (w_info[0].startsWith("end")) {
					// new synonym
					if (entry.size()==0) {
						if (dictionary.containsKey(w.trim())) {
							entry = dictionary.get(w.trim());
							
						}
						
						if (dictionaryfd.containsKey(wfd.trim())) {
							entryfd = dictionaryfd.get(wfd.trim());
						}
					}
					
					System.out.println(synt);

					if (!entry.contains(w.trim())) {
						if (synt_patterns.contains(synt)){
							System.err.println(synt);

							entry.add(w.trim());
							
							wfd += synt;
							entryfd.add(wfd.trim());
						}
					}
					w = "";
					wfd = "";
					synt = "";
				}
				
				if (w_info[0].equals("endline")) {
					// new entry
					if (entry.size() > 0) {
						dictionary.put(entry.get(0), entry);
					}
					
					if (entryfd.size() > 0) {
						dictionaryfd.put(entryfd.get(0), entryfd);
					}
					
					entry = new ArrayList<String>();
					w = "";
					synt = "";
					entryfd = new ArrayList<String>();
					wfd = "";

					openbracket = false;
				} else if (w_info[0].equals("(")) {
					openbracket = true;
				} else if (w_info[0].equals(")")) {
					openbracket = false;
				}else if (!w_info[0].startsWith("END")) {
					
					if (w_info.length < 3) continue;
					if (!openbracket) {
						w += w_info[1] + " " + w_info[2].substring(0,1) + " ";
						wfd += w_info[0] + " ";
						synt += w_info[2].substring(0,1);
					}
				}
				
			}
			
			List sortedKeys=new ArrayList(dictionary.keySet());
			Collections.sort(sortedKeys);
			
			for (Object key : sortedKeys) {
				entry = dictionary.get((String)key);
				for (String word : entry) {
					wr.write(word + "\n");
				}
//				wr.write("\n");
				wr.flush();
			}
		
			sortedKeys=new ArrayList(dictionaryfd.keySet());
			Collections.sort(sortedKeys);
			for (Object key : sortedKeys) {
				entryfd = dictionaryfd.get((String)key);
				for (String word : entryfd) {
					wrfd.write(word + "\n");
				}
//				wr.write("\n");
				wrfd.flush();
			}

			sc.close();
			wr.flush();
			wr.close();
			wrfd.flush();
			wrfd.close();
			
		} catch(FileNotFoundException e) {
			e.printStackTrace();				
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
