package bg.bas.dcl.mwe.controller;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Scanner;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;


import bg.bas.dcl.mwe.entities.Sentence;
import bg.bas.dcl.mwe.entities.Text;
import bg.bas.dcl.mwe.entities.Word;
import bg.bas.dcl.mwe.gui.bgMWEGUI;
import bg.bas.dcl.mwe.model.bgMWEModel;

public class bgMWEController {
	
	private bgMWEGUI gui;
	private bgMWEModel model;
//	private bgMWEModel model;
	public StyledDocument doc;
	
	final String NL = System.getProperty("line.separator");

	
	public bgMWEController(bgMWEGUI gui,bgMWEModel model){
		this.gui = gui;
		this.model = model;
		
       	doc = bgMWEGUI.textPane.getStyledDocument();
       	try {
			doc.remove(0, doc.getLength());
		} catch (BadLocationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        bgMWEGUI.addStylesToDocument(doc);

		this.gui.setOpenFileListener(new OpenFileListener());
		System.out.println("Controller initialised...");

	}
	
	
   	class OpenFileListener implements ActionListener {
		public void actionPerformed(ActionEvent e){
			// open fileChooser
			
			JFileChooser chooser = new JFileChooser("");

    		int option = chooser.showOpenDialog(gui);
    			
    		if (option == JFileChooser.APPROVE_OPTION) {
    				File f = chooser.getSelectedFile();
    				final String path = f.getAbsolutePath();
    				
    		        JButton button = new JButton();
//    		        if (soundIcon != null) {
    		 //           button.setIcon(soundIcon);
    		  //      } else {
    		            button.setText(path);
    		   //     }
    		        button.setCursor(Cursor.getDefaultCursor());
    		        button.setMargin(new Insets(0,0,0,0));
    		        button.setActionCommand(bgMWEGUI.buttonString);
    		        button.setBorder(
    		          		BorderFactory.createEmptyBorder(0, 0, 6, 0));
    		        button.setBackground(
    		          		Color.WHITE);

    		        LoadTextListener ltl = new LoadTextListener(path);
    		        button.addActionListener(ltl);
    		    	
    				
    				gui.corpusPanel.add(button);
//    				loadFile(f);
    				
    				
    				gui.corpusPanel.updateUI();

    		} else {
        			System.out.println("Open file cancelled ");
    				
    		}
		}
 			// open file and load it in openmath tab
	};
	
	class LoadTextListener implements ActionListener {
		String path = "";
		

		
		public LoadTextListener(String path) {
			this.path = path;
		}
		
		public void actionPerformed(ActionEvent e){
			
			System.out.println("Loading text...");
			
	        try {
//	        	doc.remove(0, doc.getLength());
//	        	bgMWEGUI.textPane.updateUI();

		        Text text = model.processXML(path);
		        System.out.println("XML processed...");
		        for (Sentence sen : text) {
		        	for (Word w : sen) {
		        		if (! w.isEmpty()) { 
		        			if (w.isMWE()) {
		        				
		        				Style s = doc.addStyle("button", doc.getStyle("regular"));
		        		        StyleConstants.setAlignment(s, StyleConstants.ALIGN_LEFT);
		        		         
		        		        JButton button = new JButton(w.getWord());

		        		      button.setCursor(Cursor.getDefaultCursor());
		        		      button.setMargin(new Insets(0,0,0,0));
		        		      button.setActionCommand("JButton");

		        		      Box buttonBox = Box.createVerticalBox();
		        		      buttonBox.setBorder(
		        		      		BorderFactory.createEmptyBorder(0, 0, 6, 0));
		        		      button.setBorder(
		        		      		BorderFactory.createEmptyBorder(0, 0, 6, 0));
		        		      button.setBackground(
		        		      		Color.WHITE);
		        		      button.setForeground(
			        		      		Color.BLUE);
		        		     buttonBox.add(button);
		        		      StyleConstants.setComponent(s, buttonBox);

		        				
		        				doc.insertString(doc.getLength(), w.getWord() + " ",
		                                 doc.getStyle("button"));
		        				doc.insertString(doc.getLength(),  " ",
		                                 doc.getStyle("regular"));
		        			} else {
		        				doc.insertString(doc.getLength(), w.getWord() + " ",
	                                 doc.getStyle("text"));
		        			}
		        		}
		        	}
		        	doc.insertString(doc.getLength(), NL,
                            doc.getStyle("text"));
		        }
		        
		        
	        } catch (Exception ex) {
	        }

			bgMWEGUI.textPane.updateUI();
		}
    }


}
