package bg.bas.dcl.mwe.gui;

/**
 * Ivelina Stoyanova
 */ 

/**
 * 
 */

import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.text.*;

import java.awt.*;              //for layout managers and more
import java.awt.event.*;        //for action events
import java.awt.image.BufferedImage;

import java.net.URL;
import java.util.Scanner;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

public class bgMWEGUI extends JFrame {
    private String newline = "\n";
    protected static final String textFieldString = "JTextField";
    protected static final String ftfString = "JFormattedTextField";
    public static final String buttonString = "JButton";
    
    
    public static JPanel main;
    public static JPanel corpusPanel;
    public static JTextPane textPane;
    public static JPanel infoPanel;
    public static JMenu menu;
    
    public JScrollPane corpusPanel_scroll;
    public static JScrollPane textPanel_scroll;

    protected JLabel actionLabel;
	public static String NL = System.getProperty("line.separator");
	
	
	static ActionListener openFileListener;


    public bgMWEGUI() {
    	
    	this.setTitle("bgMWE Extractor");
        setLayout(new BorderLayout());
        
        
        corpusPanel = new JPanel();   
        corpusPanel.setLayout(new BoxLayout(corpusPanel, BoxLayout.PAGE_AXIS));
        corpusPanel_scroll = new JScrollPane(corpusPanel);
        corpusPanel_scroll.setPreferredSize(new Dimension(200, 500));

        textPane = new JTextPane();
        textPane.setLayout(new FlowLayout());

        textPanel_scroll = new JScrollPane(textPane);
        textPanel_scroll.setPreferredSize(new Dimension(900, 500));
        textPanel_scroll.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
 
        
        infoPanel = new JPanel();
        
        main = new JPanel();
        main.add(corpusPanel_scroll, BorderLayout.WEST);
        main.add(textPanel_scroll, BorderLayout.CENTER);
        main.add(infoPanel, BorderLayout.EAST);

        this.setJMenuBar(setupMenu());
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Add content to the window.
        this.setContentPane(main);


        //Display the window.
        this.pack();
        this.setVisible(true);

        /**
        //Create a regular text field.
        JTextField textField = new JTextField(10);
        textField.setActionCommand(textFieldString);
        textField.addActionListener(this);

        //Create a password field.
        JPasswordField passwordField = new JPasswordField(10);
        passwordField.setActionCommand(passwordFieldString);
        passwordField.addActionListener(this);

        //Create a formatted text field.
        JFormattedTextField ftf = new JFormattedTextField(
                java.util.Calendar.getInstance().getTime());
        ftf.setActionCommand(textFieldString);
        ftf.addActionListener(this);

        //Create some labels for the fields.
        JLabel textFieldLabel = new JLabel(textFieldString + ": ");
        textFieldLabel.setLabelFor(textField);
        JLabel passwordFieldLabel = new JLabel(passwordFieldString + ": ");
        passwordFieldLabel.setLabelFor(passwordField);
        JLabel ftfLabel = new JLabel(ftfString + ": ");
        ftfLabel.setLabelFor(ftf);

        //Create a label to put messages during an action event.
        actionLabel = new JLabel("Type text in a field and press Enter.");
        actionLabel.setBorder(BorderFactory.createEmptyBorder(10,0,0,0));

        //Lay out the text controls and the labels.
        JPanel textControlsPane = new JPanel();
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        textControlsPane.setLayout(gridbag);

        JLabel[] labels = {textFieldLabel, passwordFieldLabel, ftfLabel};
        JTextField[] textFields = {textField, passwordField, ftf};
        addLabelTextRows(labels, textFields, gridbag, textControlsPane);

        c.gridwidth = GridBagConstraints.REMAINDER; //last
        c.anchor = GridBagConstraints.WEST;
        c.weightx = 1.0;
        textControlsPane.add(actionLabel, c);
        textControlsPane.setBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("Text Fields"),
                                BorderFactory.createEmptyBorder(5,5,5,5)));

        //Create a text area.
        JTextArea textArea = new JTextArea(
                "This is an editable JTextArea. " +
                "A text area is a \"plain\" text component, " +
                "which means that although it can display text " +
                "in any font, all of the text is in the same font."
        );
        textArea.setFont(new Font("Serif", Font.ITALIC, 16));
        textArea.setLineWrap(true);
        textArea.setWrapStyleWord(true);
        JScrollPane areaScrollPane = new JScrollPane(textArea);
        areaScrollPane.setVerticalScrollBarPolicy(
                        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        areaScrollPane.setPreferredSize(new Dimension(250, 250));
        areaScrollPane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("Plain Text"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                areaScrollPane.getBorder()));

        //Create an editor pane.
        JEditorPane editorPane = createEditorPane();
        JScrollPane editorScrollPane = new JScrollPane(editorPane);
        editorScrollPane.setVerticalScrollBarPolicy(
                        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        editorScrollPane.setPreferredSize(new Dimension(250, 145));
        editorScrollPane.setMinimumSize(new Dimension(10, 10));

        //Create a text pane.
        JTextPane textPane = createTextPane();
        JScrollPane paneScrollPane = new JScrollPane(textPane);
        paneScrollPane.setVerticalScrollBarPolicy(
                        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        paneScrollPane.setPreferredSize(new Dimension(250, 155));
        paneScrollPane.setMinimumSize(new Dimension(10, 10));

        //Put the editor pane and the text pane in a split pane.
        JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
                                              editorScrollPane,
                                              paneScrollPane);
        splitPane.setOneTouchExpandable(true);
        splitPane.setResizeWeight(0.5);
        JPanel rightPane = new JPanel(new GridLayout(1,0));
        rightPane.add(splitPane);
        rightPane.setBorder(BorderFactory.createCompoundBorder(
                        BorderFactory.createTitledBorder("Styled Text"),
                        BorderFactory.createEmptyBorder(5,5,5,5)));


        //Put everything together.
        JPanel leftPane = new JPanel(new BorderLayout());
        leftPane.add(textControlsPane, 
                     BorderLayout.PAGE_START);
        leftPane.add(areaScrollPane,
                     BorderLayout.CENTER);

        add(leftPane, BorderLayout.LINE_START);
        add(rightPane, BorderLayout.LINE_END);
        */
    }

    private void addLabelTextRows(JLabel[] labels,
                                  JTextField[] textFields,
                                  GridBagLayout gridbag,
                                  Container container) {
        GridBagConstraints c = new GridBagConstraints();
        c.anchor = GridBagConstraints.EAST;
        int numLabels = labels.length;

        for (int i = 0; i < numLabels; i++) {
            c.gridwidth = GridBagConstraints.RELATIVE; //next-to-last
            c.fill = GridBagConstraints.NONE;      //reset to default
            c.weightx = 0.0;                       //reset to default
            container.add(labels[i], c);

            c.gridwidth = GridBagConstraints.REMAINDER;     //end row
            c.fill = GridBagConstraints.HORIZONTAL;
            c.weightx = 1.0;
            container.add(textFields[i], c);
        }
    }

    public void actionPerformed(ActionEvent e) {
        String prefix = "You typed \"";
        if (textFieldString.equals(e.getActionCommand())) {
            JTextField source = (JTextField)e.getSource();
            actionLabel.setText(prefix + source.getText() + "\"");
        } else if (buttonString.equals(e.getActionCommand())) {
            Toolkit.getDefaultToolkit().beep();
        }
    }

    private JEditorPane createEditorPane() {
        JEditorPane editorPane = new JEditorPane();
        editorPane.setEditable(false);
        java.net.URL helpURL = bgMWEGUI.class.getResource(
                                        "bgMWEGUI.html");
        if (helpURL != null) {
            try {
                editorPane.setPage(helpURL);
            } catch (IOException e) {
                System.err.println("Attempted to read a bad URL: " + helpURL);
            }
        } else {
            System.err.println("Couldn't find file: TextSampleDemoHelp.html");
        }

        return editorPane;
    }

    private JTextPane createTextPane() {
        String[] initString =
                { "Някакъв текст, ",            //regular
                  "another ",                                   //italic
                  "styled ",                                    //bold
                  "text ",                                      //small
                  "component, ",                                //large
                  "which supports embedded components..." + newline,//regular
                  " " ,                                //button
                  "...and embedded icons..." + newline,         //regular
                  " ",                                          //icon
                   "JTextPane is a subclass of JEditorPane that " +
                    "uses a StyledEditorKit and StyledDocument, and provides " +
                    "cover methods for interacting with those objects."
                 };

        String[] initStyles =
                { "regular", "italic", "bold", "small", "large",
                  "regular", "button", "regular", "icon",
                  "regular"
                };

        JTextPane textPane = new JTextPane();
        textPane.setLayout(new FlowLayout());
        StyledDocument doc = textPane.getStyledDocument();
        addStylesToDocument(doc);


        try {
            for (int i=0; i < initString.length; i++) {
                doc.insertString(doc.getLength(), initString[i],
                                 doc.getStyle(initStyles[i]));
            }
        } catch (BadLocationException ble) {
            System.err.println("Couldn't insert initial text into text pane.");
        }

        return textPane;
    }

    public static void addStylesToDocument(StyledDocument doc) {
        //Initialize some styles.
        Style def = StyleContext.getDefaultStyleContext().
                        getStyle(StyleContext.DEFAULT_STYLE);

        Style regular = doc.addStyle("text", def);
        StyleConstants.setFontFamily(def, "SansSerif");

        Style s = doc.addStyle("italic", regular);
        StyleConstants.setItalic(s, true);

        s = doc.addStyle("bold", regular);
        StyleConstants.setBold(s, true);

        s = doc.addStyle("small", regular);
        StyleConstants.setFontSize(s, 10);

        s = doc.addStyle("large", regular);
        StyleConstants.setFontSize(s, 16);

        s = doc.addStyle("icon", regular);
        StyleConstants.setAlignment(s, StyleConstants.ALIGN_LEFT);
        ImageIcon pigIcon = createImageIcon("images/Pig.gif",
                                            "a cute pig");
        if (pigIcon != null) {
            StyleConstants.setIcon(s, pigIcon);
        }

        s = doc.addStyle("button", regular);
        StyleConstants.setAlignment(s, StyleConstants.ALIGN_LEFT);
         
        JButton button = new JButton();

      button.setCursor(Cursor.getDefaultCursor());
      button.setMargin(new Insets(0,0,0,0));
      button.setActionCommand("JButton");

      Box buttonBox = Box.createVerticalBox();
      buttonBox.setBorder(
      		BorderFactory.createEmptyBorder(0, 0, 6, 0));
      button.setBorder(
      		BorderFactory.createEmptyBorder(0, 0, 6, 0));
      button.setBackground(
      		Color.WHITE);
     buttonBox.add(button);
      StyleConstants.setComponent(s, buttonBox);
       

    }

    /** Returns an ImageIcon, or null if the path was invalid. */
    protected static ImageIcon createImageIcon(String path,
                                               String description) {
        java.net.URL imgURL = bgMWEGUI.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL, description);
        } else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }

    
    public void setOpenFileListener(ActionListener ofl) {
        openFileListener = ofl;
        this.setJMenuBar(setupMenu());
    }
        
    
    /**
     * setup menu
     */
    
    private static JMenuBar setupMenu( )
    {
    	JMenuBar menu = new JMenuBar();
    	JMenu fileMenu = new JMenu("File");
    	fileMenu.setMnemonic(KeyEvent.VK_F);
    	String[] fileItems = new String[] {"New corpus","Open file","Save all","Save OpenMath","Save LaTex","Save Image","Exit"};
    	char[] fileShortcuts = new char[] {'N','O','S','M','L','I','X'};

    	    	
    	JMenu editMenu = new JMenu("Edit");
    	editMenu.setMnemonic(KeyEvent.VK_E);
    	String[] editItems = new String[] {"Cut","Copy","Paste"};
    	char[] editShortcuts = new char[] {'T','C','P'};
    	
    	JMenu toolsMenu = new JMenu("Tools");
    	toolsMenu.setMnemonic(KeyEvent.VK_T);
    	String[] toolsItems = new String[] {"Update OpenMath","Options","Summarise all","Customised","Expand all"};
    	char[] toolsShortcuts = new char[] {'U','O','S','C','E'};
    	
    	JMenu helpMenu = new JMenu("Help");
    	helpMenu.setMnemonic(KeyEvent.VK_H);
    	String[] helpItems = new String[] {"About","User Manual","Online help"};
    	char[] helpShortcuts = new char[] {'A','M','O'};
    	
 
       	ActionListener[] fileListeners = new ActionListener[] {openFileListener,
       			openFileListener,openFileListener,openFileListener,openFileListener,openFileListener,openFileListener};

 
   	for (int i=0; i< fileItems.length; i++){
		JMenuItem item = new JMenuItem(fileItems[i],fileShortcuts[i]);
		item.addActionListener(fileListeners[i]);
		fileMenu.add(item);
   	}

    	
    	menu.add(fileMenu);
    	menu.add(editMenu);
    	menu.add(toolsMenu);
    	menu.add(helpMenu);
    	
    	return menu;
    }


}
